/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse expparse
#define yylex   explex
#define yyerror experror
#define yylval  explval
#define yychar  expchar
#define yydebug expdebug
#define yynerrs expnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INT = 258,
     IDENTIFIER = 259,
     FUNC = 260,
     FUNC1 = 261,
     REAL = 262,
     COMPLEX = 263,
     IF = 264,
     THEN = 265,
     ELSE = 266,
     WHILE = 267,
     DO = 268,
     FOR = 269,
     IN = 270,
     STRING = 271,
     PVIRG = 272,
     NEWLINE = 273,
     LEFT_PAR = 274,
     RIGHT_PAR = 275,
     LEFT_RECT = 276,
     RIGHT_RECT = 277,
     RIGHT_CHAV = 278,
     VIRG = 279,
     RANGE = 280,
     OP_STORE = 281,
     OP_ATRIB = 282,
     EQ_GT = 283,
     NE = 284,
     EQ = 285,
     GE = 286,
     GT = 287,
     LE = 288,
     LT = 289,
     OP_MINUS = 290,
     OP_PLUS = 291,
     OP_PERCENT = 292,
     OP_OVER = 293,
     OP_TIMES = 294,
     NOT = 295,
     OR = 296,
     AND = 297,
     UMINUS = 298,
     OP_DEC = 299,
     OP_INC = 300,
     FACTORIAL = 301,
     SIZE = 302,
     OP_CIRC = 303,
     LEFT_CHAV = 304,
     OP_SETA = 305
   };
#endif
/* Tokens.  */
#define INT 258
#define IDENTIFIER 259
#define FUNC 260
#define FUNC1 261
#define REAL 262
#define COMPLEX 263
#define IF 264
#define THEN 265
#define ELSE 266
#define WHILE 267
#define DO 268
#define FOR 269
#define IN 270
#define STRING 271
#define PVIRG 272
#define NEWLINE 273
#define LEFT_PAR 274
#define RIGHT_PAR 275
#define LEFT_RECT 276
#define RIGHT_RECT 277
#define RIGHT_CHAV 278
#define VIRG 279
#define RANGE 280
#define OP_STORE 281
#define OP_ATRIB 282
#define EQ_GT 283
#define NE 284
#define EQ 285
#define GE 286
#define GT 287
#define LE 288
#define LT 289
#define OP_MINUS 290
#define OP_PLUS 291
#define OP_PERCENT 292
#define OP_OVER 293
#define OP_TIMES 294
#define NOT 295
#define OR 296
#define AND 297
#define UMINUS 298
#define OP_DEC 299
#define OP_INC 300
#define FACTORIAL 301
#define SIZE 302
#define OP_CIRC 303
#define LEFT_CHAV 304
#define OP_SETA 305




/* Copy the first part of user declarations.  */
#line 1 "grammar.y"

/* system includes */
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nxp_kernel.h"
#include "parser.h"
#include "i18n.h"

#define YYERROR_VERBOSE



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 21 "grammar.y"
{
  GHashTable *hash;
  NxpElement *el;
  NxpElement *atom;
  NxpOp f;
  GPtrArray *array;
  char* str;
  NxpIdentifier *id;
  NxpElement *list;
  NxpArg args;
}
/* Line 187 of yacc.c.  */
#line 231 "grammar.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 244 "grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  55
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1046

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  51
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  17
/* YYNRULES -- Number of rules.  */
#define YYNRULES  75
/* YYNRULES -- Number of states.  */
#define YYNSTATES  161

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    11,    15,    19,    23,    27,
      31,    35,    39,    42,    46,    50,    54,    58,    62,    65,
      67,    70,    74,    78,    80,    84,    88,    92,    95,    97,
     101,   103,   107,   110,   114,   122,   124,   127,   130,   133,
     137,   141,   145,   149,   151,   153,   155,   157,   159,   161,
     163,   165,   167,   171,   177,   179,   186,   197,   204,   213,
     222,   231,   238,   245,   249,   253,   256,   259,   263,   269,
     272,   274,   278,   282,   284,   287
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      52,     0,    -1,    58,    -1,    54,    -1,    53,    34,    53,
      -1,    53,    33,    53,    -1,    53,    31,    53,    -1,    53,
      32,    53,    -1,    53,    29,    53,    -1,    53,    30,    53,
      -1,    53,    42,    53,    -1,    53,    41,    53,    -1,    40,
      53,    -1,    21,    58,    22,    -1,    53,    27,    53,    -1,
      53,    27,     1,    -1,    53,    26,    53,    -1,    53,    26,
       1,    -1,    47,    53,    -1,    55,    -1,    35,    55,    -1,
      54,    36,    55,    -1,    54,    35,    55,    -1,    56,    -1,
      55,    39,    56,    -1,    55,    38,    56,    -1,    55,    37,
      56,    -1,    55,    56,    -1,    57,    -1,    56,    48,    57,
      -1,    60,    -1,    19,    53,    20,    -1,    57,    46,    -1,
      57,    50,    57,    -1,    57,    50,    19,    57,    24,    57,
      20,    -1,    18,    -1,    53,    18,    -1,    53,    17,    -1,
      58,    18,    -1,    58,    53,    18,    -1,    58,    53,    17,
      -1,    65,    17,    65,    -1,    59,    17,    65,    -1,     3,
      -1,     7,    -1,     8,    -1,    16,    -1,    62,    -1,    67,
      -1,    64,    -1,    66,    -1,    53,    -1,    61,    24,    53,
      -1,    61,    24,     4,    28,    53,    -1,    63,    -1,     9,
      53,    10,    21,    58,    22,    -1,     9,    53,    10,    21,
      58,    22,    11,    21,    58,    22,    -1,     9,    21,    53,
      24,    53,    22,    -1,     9,    21,    53,    24,    53,    24,
      53,    22,    -1,    14,    67,    15,    53,    13,    21,    58,
      22,    -1,    14,    21,    67,    24,    53,    24,    53,    22,
      -1,    12,    53,    13,    21,    58,    22,    -1,    12,    21,
      53,    24,    61,    22,    -1,     5,    61,    22,    -1,     6,
      61,    20,    -1,     5,    22,    -1,     6,    20,    -1,    49,
      65,    23,    -1,    49,    53,    25,    53,    23,    -1,    49,
      23,    -1,    53,    -1,    65,    24,    53,    -1,    49,    59,
      23,    -1,     4,    -1,    45,    67,    -1,    44,    67,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    98,    98,   121,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   137,   142,   147,   155,   161,   238,
     239,   240,   241,   245,   246,   247,   248,   249,   253,   254,
     258,   259,   260,   265,   271,   280,   283,   284,   285,   286,
     287,   295,   302,   313,   314,   315,   316,   317,   318,   319,
     320,   324,   332,   337,   346,   347,   359,   374,   383,   393,
     405,   416,   424,   435,   440,   446,   452,   461,   476,   479,
     486,   492,   497,   531,   535,   539
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INT", "IDENTIFIER", "FUNC", "FUNC1",
  "REAL", "COMPLEX", "IF", "THEN", "ELSE", "WHILE", "DO", "FOR", "IN",
  "STRING", "PVIRG", "NEWLINE", "LEFT_PAR", "RIGHT_PAR", "LEFT_RECT",
  "RIGHT_RECT", "RIGHT_CHAV", "VIRG", "RANGE", "OP_STORE", "OP_ATRIB",
  "EQ_GT", "NE", "EQ", "GE", "GT", "LE", "LT", "OP_MINUS", "OP_PLUS",
  "OP_PERCENT", "OP_OVER", "OP_TIMES", "NOT", "OR", "AND", "UMINUS",
  "OP_DEC", "OP_INC", "FACTORIAL", "SIZE", "OP_CIRC", "LEFT_CHAV",
  "OP_SETA", "$accept", "line", "expression", "sum", "product", "power",
  "expr", "block", "matrix_line", "atom", "arg_list", "function", "func",
  "vector", "vector_line", "matrix", "variable", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    51,    52,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    54,
      54,    54,    54,    55,    55,    55,    55,    55,    56,    56,
      57,    57,    57,    57,    57,    58,    58,    58,    58,    58,
      58,    59,    59,    60,    60,    60,    60,    60,    60,    60,
      60,    61,    61,    61,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    63,    63,    63,    63,    64,    64,    64,
      65,    65,    66,    67,    67,    67
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     2,     1,
       2,     3,     3,     1,     3,     3,     3,     2,     1,     3,
       1,     3,     2,     3,     7,     1,     2,     2,     2,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     1,     6,    10,     6,     8,     8,
       8,     6,     6,     3,     3,     2,     2,     3,     5,     2,
       1,     3,     3,     1,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    43,    73,     0,     0,    44,    45,     0,     0,     0,
      46,    35,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,    19,    23,    28,     2,    30,    47,    54,
      49,    50,    48,    65,    51,     0,    66,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20,    12,    75,    74,
      18,    69,    70,     0,     0,     1,    37,    36,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,     0,    32,     0,    38,     0,    63,
       0,    64,     0,     0,     0,     0,     0,     0,    31,    13,
       0,     0,    72,     0,    67,     0,    17,    16,    15,    14,
       8,     9,     6,     7,     5,     4,    11,    10,    22,    21,
      26,    25,    24,    29,     0,    33,    40,    39,    73,    52,
       0,     0,     0,     0,     0,     0,     0,    70,    42,    41,
      71,    28,     0,     0,     0,     0,     0,     0,     0,    68,
       0,    53,    57,     0,    55,    62,    61,     0,     0,     0,
       0,     0,     0,     0,    34,    58,     0,    60,    59,     0,
      56
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    20,    21,    22,    23,    24,    25,    45,    53,    27,
      35,    28,    29,    30,    54,    31,    32
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -69
static const yytype_int16 yypact[] =
{
     380,   -69,   -69,   427,   449,   -69,   -69,   563,   610,     6,
     -69,   -69,   630,   380,    93,   630,     9,     9,   630,   496,
      20,   843,     8,   697,   -20,   -25,   543,   -69,   -69,   -69,
     -69,   -69,   -69,   -69,  1004,    10,   -69,     2,   380,   735,
     380,   765,     9,    24,   878,   226,   697,   -69,   -69,   -69,
     -69,   -69,   987,    -6,     7,   -69,   -69,   -69,   157,   179,
     630,   630,   630,   630,   630,   630,   630,   630,    93,    93,
      93,    93,    93,   -20,    93,   -69,   744,   -69,   861,   -69,
     677,   -69,   806,    53,   825,    54,    28,   630,   -69,   -69,
     630,   630,   -69,   630,   -69,   630,   -69,  1004,   -69,  1004,
      29,    29,    29,    29,    29,    29,   -69,   -69,   697,   697,
     -20,   -20,   -20,   -25,   630,   -69,   -69,   -69,    51,  1004,
     630,   380,   630,   380,   630,   787,   950,  1004,    56,    56,
    1004,   -17,   630,   899,   246,    14,   293,   969,    60,   -69,
      93,  1004,   -69,   630,    71,   -69,   -69,   630,   380,    -1,
     916,    62,   933,   313,   -69,   -69,   380,   -69,   -69,   360,
     -69
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -69,   -69,    -3,   -69,     0,    -5,   -68,     3,   -69,   -69,
      -2,   -69,   -69,   -69,   -15,   -69,    31
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      34,    34,    37,    26,    39,    41,   113,   140,   115,    44,
       2,    91,    47,     2,    46,    50,    52,    92,    73,   154,
      55,    75,    81,    78,    93,    76,    80,    42,    74,    75,
      94,    95,    79,    76,    80,    82,   145,    84,    80,    87,
      43,    73,    78,    68,    69,    75,   131,    48,    49,    76,
      16,    17,   124,    16,    17,    97,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   110,   111,   112,   108,   109,
      66,    67,   149,    86,   121,   123,   128,   119,   129,   132,
      95,   148,   151,   156,   125,     0,     0,   126,   127,     0,
     127,     0,   130,     0,     0,     0,     1,     2,     3,     4,
       5,     6,     7,    73,    73,     8,     0,     9,     0,    10,
       0,    44,    12,     0,     0,     0,     0,   133,     0,    34,
     135,   137,     0,     0,   134,     0,   136,     0,     0,   141,
       0,    78,     0,    78,     0,     0,     0,    16,    17,     0,
     150,     0,    19,     0,   152,     0,     0,     0,     0,     0,
      78,   153,     0,     0,     0,     0,    78,     0,    96,   159,
       1,     2,     3,     4,     5,     6,     7,     0,     0,     8,
       0,     9,     0,    10,     0,     0,    12,     0,    13,     0,
      98,     0,     1,     2,     3,     4,     5,     6,     7,     0,
       0,     8,    14,     9,     0,    10,     0,    15,    12,     0,
      13,    16,    17,     0,    18,     0,    19,     0,     0,     0,
       0,     0,     0,     0,    14,     0,     0,     0,     0,    15,
       0,     0,     0,    16,    17,     0,    18,     0,    19,     1,
       2,     3,     4,     5,     6,     7,     0,     0,     8,     0,
       9,     0,    10,     0,    77,    12,     0,    13,    89,     1,
       2,     3,     4,     5,     6,     7,     0,     0,     8,     0,
       9,    14,    10,     0,    77,    12,    15,    13,   144,     0,
      16,    17,     0,    18,     0,    19,     0,     0,     0,     0,
       0,    14,     0,     0,     0,     0,    15,     0,     0,     0,
      16,    17,     0,    18,     0,    19,     1,     2,     3,     4,
       5,     6,     7,     0,     0,     8,     0,     9,     0,    10,
       0,    77,    12,     0,    13,   146,     1,     2,     3,     4,
       5,     6,     7,     0,     0,     8,     0,     9,    14,    10,
       0,    77,    12,    15,    13,   158,     0,    16,    17,     0,
      18,     0,    19,     0,     0,     0,     0,     0,    14,     0,
       0,     0,     0,    15,     0,     0,     0,    16,    17,     0,
      18,     0,    19,     1,     2,     3,     4,     5,     6,     7,
       0,     0,     8,     0,     9,     0,    10,     0,    77,    12,
       0,    13,   160,     1,     2,     3,     4,     5,     6,     7,
       0,     0,     8,     0,     9,    14,    10,     0,    11,    12,
      15,    13,     0,     0,    16,    17,     0,    18,     0,    19,
       0,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,    16,    17,     0,    18,     0,    19,
       1,     2,     3,     4,     5,     6,     7,     0,     0,     8,
       0,     9,     0,    10,     0,     0,    12,     0,    13,    33,
       0,     0,     1,     2,     3,     4,     5,     6,     7,     0,
       0,     8,    14,     9,     0,    10,     0,    15,    12,    36,
      13,    16,    17,     0,    18,     0,    19,     0,     0,     0,
       0,     0,     0,     0,    14,     0,     0,     0,     0,    15,
       0,     0,     0,    16,    17,     0,    18,     0,    19,     1,
       2,     3,     4,     5,     6,     7,     0,     0,     8,     0,
       9,     0,    10,     0,     0,    12,     0,    13,     0,    51,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    14,     0,     0,     0,     0,    15,     0,     0,     0,
      16,    17,     0,    18,     0,    19,     1,     2,     3,     4,
       5,     6,     7,     0,     0,     8,     0,     9,     0,    10,
       0,    77,    12,     0,    13,     0,     1,     2,     3,     4,
       5,     6,     7,     0,     0,     8,     0,     9,    14,    10,
       0,     0,    12,    15,    38,     0,     0,    16,    17,     0,
      18,     0,    19,     0,     0,     0,     0,     0,    14,     0,
       0,     0,     0,    15,     0,     0,     0,    16,    17,     0,
      18,     0,    19,     1,     2,     3,     4,     5,     6,     7,
       0,     0,     8,     0,     9,     0,    10,     0,     0,    12,
       0,    40,     0,     1,     2,     3,     4,     5,     6,     7,
       0,     0,     8,     0,     9,    14,    10,     0,     0,    12,
      15,    13,     0,     0,    16,    17,     0,    18,     0,    19,
       0,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,    16,    17,     0,    18,     0,    19,
       1,   118,     3,     4,     5,     6,     7,     0,     0,     8,
       0,     9,     0,    10,     0,     0,    12,     0,    13,     0,
       1,     2,     3,     4,     5,     6,     7,     0,     0,     8,
       0,     9,    14,    10,     0,     0,    12,    15,     0,     0,
       0,    16,    17,     0,    18,     0,    19,     0,     0,     0,
       0,     0,     0,     0,    70,    71,    72,     0,     0,     0,
       0,    16,    17,     0,     0,    83,    19,     1,     2,     3,
       4,     5,     6,     7,     0,     0,     8,     0,     9,     0,
      10,    58,    59,   114,    60,    61,    62,    63,    64,    65,
       0,     0,     0,     0,     0,     0,    66,    67,    85,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,    58,    59,    19,    60,    61,    62,    63,    64,    65,
     138,     0,     0,     0,     0,     0,    66,    67,     0,     0,
       0,     0,     0,    58,    59,     0,    60,    61,    62,    63,
      64,    65,     0,    56,    57,     0,     0,     0,    66,    67,
     120,     0,    58,    59,     0,    60,    61,    62,    63,    64,
      65,     0,    56,    57,     0,     0,     0,    66,    67,   122,
       0,    58,    59,     0,    60,    61,    62,    63,    64,    65,
      56,    57,     0,     0,     0,     0,    66,    67,     0,    58,
      59,     0,    60,    61,    62,    63,    64,    65,   116,   117,
       0,     0,     0,     0,    66,    67,     0,    58,    59,     0,
      60,    61,    62,    63,    64,    65,     0,     0,    88,     0,
       0,     0,    66,    67,    58,    59,     0,    60,    61,    62,
      63,    64,    65,     0,     0,     0,     0,     0,     0,    66,
      67,   142,     0,   143,     0,    58,    59,     0,    60,    61,
      62,    63,    64,    65,     0,     0,     0,     0,   155,     0,
      66,    67,    58,    59,     0,    60,    61,    62,    63,    64,
      65,     0,     0,     0,     0,   157,     0,    66,    67,    58,
      59,     0,    60,    61,    62,    63,    64,    65,     0,     0,
       0,     0,     0,   139,    66,    67,    58,    59,     0,    60,
      61,    62,    63,    64,    65,     0,     0,     0,     0,     0,
       0,    66,    67,   147,     0,    58,    59,     0,    60,    61,
      62,    63,    64,    65,     0,     0,     0,     0,     0,     0,
      66,    67,    90,    58,    59,     0,    60,    61,    62,    63,
      64,    65,     0,     0,     0,     0,     0,     0,    66,    67,
      58,    59,     0,    60,    61,    62,    63,    64,    65,     0,
       0,     0,     0,     0,     0,    66,    67
};

static const yytype_int16 yycheck[] =
{
       3,     4,     4,     0,     7,     8,    74,    24,    76,    12,
       4,    17,    15,     4,    14,    18,    19,    23,    23,    20,
       0,    46,    20,    26,    17,    50,    24,    21,    48,    46,
      23,    24,    22,    50,    24,    38,    22,    40,    24,    15,
       9,    46,    45,    35,    36,    46,   114,    16,    17,    50,
      44,    45,    24,    44,    45,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    70,    71,    72,    68,    69,
      41,    42,   140,    42,    21,    21,    91,    80,    93,    28,
      24,    21,    11,    21,    87,    -1,    -1,    90,    91,    -1,
      93,    -1,    95,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,   108,   109,    12,    -1,    14,    -1,    16,
      -1,   114,    19,    -1,    -1,    -1,    -1,   120,    -1,   122,
     122,   124,    -1,    -1,   121,    -1,   123,    -1,    -1,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,    44,    45,    -1,
     143,    -1,    49,    -1,   147,    -1,    -1,    -1,    -1,    -1,
     153,   148,    -1,    -1,    -1,    -1,   159,    -1,     1,   156,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    12,
      -1,    14,    -1,    16,    -1,    -1,    19,    -1,    21,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    12,    35,    14,    -1,    16,    -1,    40,    19,    -1,
      21,    44,    45,    -1,    47,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    44,    45,    -1,    47,    -1,    49,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    12,    -1,
      14,    -1,    16,    -1,    18,    19,    -1,    21,    22,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    12,    -1,
      14,    35,    16,    -1,    18,    19,    40,    21,    22,    -1,
      44,    45,    -1,    47,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    47,    -1,    49,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    12,    -1,    14,    -1,    16,
      -1,    18,    19,    -1,    21,    22,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    12,    -1,    14,    35,    16,
      -1,    18,    19,    40,    21,    22,    -1,    44,    45,    -1,
      47,    -1,    49,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    -1,    49,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    12,    -1,    14,    -1,    16,    -1,    18,    19,
      -1,    21,    22,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    12,    -1,    14,    35,    16,    -1,    18,    19,
      40,    21,    -1,    -1,    44,    45,    -1,    47,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    -1,    49,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    12,
      -1,    14,    -1,    16,    -1,    -1,    19,    -1,    21,    22,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    12,    35,    14,    -1,    16,    -1,    40,    19,    20,
      21,    44,    45,    -1,    47,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    44,    45,    -1,    47,    -1,    49,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    12,    -1,
      14,    -1,    16,    -1,    -1,    19,    -1,    21,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    47,    -1,    49,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    12,    -1,    14,    -1,    16,
      -1,    18,    19,    -1,    21,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    12,    -1,    14,    35,    16,
      -1,    -1,    19,    40,    21,    -1,    -1,    44,    45,    -1,
      47,    -1,    49,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    -1,    49,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    12,    -1,    14,    -1,    16,    -1,    -1,    19,
      -1,    21,    -1,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    12,    -1,    14,    35,    16,    -1,    -1,    19,
      40,    21,    -1,    -1,    44,    45,    -1,    47,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    -1,    49,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    12,
      -1,    14,    -1,    16,    -1,    -1,    19,    -1,    21,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    12,
      -1,    14,    35,    16,    -1,    -1,    19,    40,    -1,    -1,
      -1,    44,    45,    -1,    47,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    39,    -1,    -1,    -1,
      -1,    44,    45,    -1,    -1,    10,    49,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    12,    -1,    14,    -1,
      16,    26,    27,    19,    29,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    45,
      -1,    26,    27,    49,    29,    30,    31,    32,    33,    34,
      13,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,    -1,
      -1,    -1,    -1,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    -1,    17,    18,    -1,    -1,    -1,    41,    42,
      24,    -1,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    -1,    17,    18,    -1,    -1,    -1,    41,    42,    24,
      -1,    26,    27,    -1,    29,    30,    31,    32,    33,    34,
      17,    18,    -1,    -1,    -1,    -1,    41,    42,    -1,    26,
      27,    -1,    29,    30,    31,    32,    33,    34,    17,    18,
      -1,    -1,    -1,    -1,    41,    42,    -1,    26,    27,    -1,
      29,    30,    31,    32,    33,    34,    -1,    -1,    20,    -1,
      -1,    -1,    41,    42,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    22,    -1,    24,    -1,    26,    27,    -1,    29,    30,
      31,    32,    33,    34,    -1,    -1,    -1,    -1,    22,    -1,
      41,    42,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    22,    -1,    41,    42,    26,
      27,    -1,    29,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    23,    41,    42,    26,    27,    -1,    29,
      30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    24,    -1,    26,    27,    -1,    29,    30,
      31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    42,    25,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,
      26,    27,    -1,    29,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    12,    14,
      16,    18,    19,    21,    35,    40,    44,    45,    47,    49,
      52,    53,    54,    55,    56,    57,    58,    60,    62,    63,
      64,    66,    67,    22,    53,    61,    20,    61,    21,    53,
      21,    53,    21,    67,    53,    58,    55,    53,    67,    67,
      53,    23,    53,    59,    65,     0,    17,    18,    26,    27,
      29,    30,    31,    32,    33,    34,    41,    42,    35,    36,
      37,    38,    39,    56,    48,    46,    50,    18,    53,    22,
      24,    20,    53,    10,    53,    13,    67,    15,    20,    22,
      25,    17,    23,    17,    23,    24,     1,    53,     1,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    55,    55,
      56,    56,    56,    57,    19,    57,    17,    18,     4,    53,
      24,    21,    24,    21,    24,    53,    53,    53,    65,    65,
      53,    57,    28,    53,    58,    61,    58,    53,    13,    23,
      24,    53,    22,    24,    22,    22,    22,    24,    21,    57,
      53,    11,    53,    58,    20,    22,    21,    22,    22,    58,
      22
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 98 "grammar.y"
    {
    NxpElementList *el = NXP_ELEMENT_LIST((yyvsp[(1) - (1)].el));
    if (el->list) {
	if (el->list->next) {
	    exp_expression = nxp_element_function_new_simple(":", NXP_ELEMENT(el));
	    NXP_ELEMENT_UNREF((NxpElement *)el);
	}
	else {
	    exp_expression = NXP_ELEMENT_REF(el->list->data);
	    NXP_ELEMENT_UNREF((NxpElement *)el);
	}
    }
    else {
	NXP_ELEMENT_UNREF(el);
	exp_expression = NULL;
    }
}
    break;

  case 3:
#line 121 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].el); }
    break;

  case 4:
#line 123 "grammar.y"
    { (yyval.el) = elem_LT((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 5:
#line 124 "grammar.y"
    { (yyval.el) = elem_LE((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 6:
#line 125 "grammar.y"
    { (yyval.el) = elem_GE((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 7:
#line 126 "grammar.y"
    { (yyval.el) = elem_GT((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 8:
#line 127 "grammar.y"
    { (yyval.el) = elem_NE((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 9:
#line 128 "grammar.y"
    { (yyval.el) = elem_EQ((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 10:
#line 129 "grammar.y"
    { (yyval.el) = elem_AND((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el)); }
    break;

  case 11:
#line 130 "grammar.y"
    { (yyval.el) = elem_OR((yyvsp[(1) - (3)].el),(yyvsp[(3) - (3)].el));  }
    break;

  case 12:
#line 131 "grammar.y"
    { (yyval.el) = elem_NOT((yyvsp[(2) - (2)].el));    }
    break;

  case 13:
#line 132 "grammar.y"
    {
    (yyval.el) = nxp_element_function_new_simple(":", (yyvsp[(2) - (3)].el));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (3)].el));
}
    break;

  case 14:
#line 137 "grammar.y"
    {
    (yyval.el) = nxp_element_tree_new(NXP_OP_EQ, (yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el));
    NXP_ELEMENT_UNREF((yyvsp[(1) - (3)].el));
    NXP_ELEMENT_UNREF((yyvsp[(3) - (3)].el));
}
    break;

  case 15:
#line 142 "grammar.y"
    {
    (yyval.el) = NULL;
    nxp_parser_error(_("Error parsing right side of assignment")); 
    YYABORT;
}
    break;

  case 16:
#line 147 "grammar.y"
    {
    NxpElement *tree;

    tree = nxp_element_tree_new(NXP_OP_COLON_EQ, (yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el));
    NXP_ELEMENT_UNREF((yyvsp[(1) - (3)].el));
    NXP_ELEMENT_UNREF((yyvsp[(3) - (3)].el));
    (yyval.el) = tree;
}
    break;

  case 17:
#line 155 "grammar.y"
    {
    (yyval.el) = NULL;
    NXP_ELEMENT_UNREF((yyvsp[(1) - (3)].el));
    nxp_parser_error(_("Error parsing right side of store operation"));
    YYABORT;
}
    break;

  case 18:
#line 161 "grammar.y"
    {
    (yyval.el) = elem_SIZE((yyvsp[(2) - (2)].el));
}
    break;

  case 19:
#line 238 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].el); }
    break;

  case 20:
#line 239 "grammar.y"
    { (yyval.el) = elem_UMINUS((yyvsp[(2) - (2)].el)); }
    break;

  case 21:
#line 240 "grammar.y"
    { (yyval.el) = elem_PLUS((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el)); }
    break;

  case 22:
#line 241 "grammar.y"
    { (yyval.el) = elem_MINUS((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el)); }
    break;

  case 23:
#line 245 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].el); }
    break;

  case 24:
#line 246 "grammar.y"
    { (yyval.el) = elem_TIMES((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el)); }
    break;

  case 25:
#line 247 "grammar.y"
    { (yyval.el) = elem_OVER((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el)); }
    break;

  case 26:
#line 248 "grammar.y"
    { (yyval.el) = elem_PERCENT((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el)); }
    break;

  case 27:
#line 249 "grammar.y"
    { (yyval.el) = elem_TIMES((yyvsp[(1) - (2)].el), (yyvsp[(2) - (2)].el)); }
    break;

  case 28:
#line 253 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].el); }
    break;

  case 29:
#line 254 "grammar.y"
    { (yyval.el) = elem_CIRC((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el)); }
    break;

  case 30:
#line 258 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].el); }
    break;

  case 31:
#line 259 "grammar.y"
    { (yyval.el) = (yyvsp[(2) - (3)].el); }
    break;

  case 32:
#line 260 "grammar.y"
    { 
    NxpElement_t* result;
    result = elem_FACTORIAL((yyvsp[(1) - (2)].el)); 
    (yyval.el) = result;
}
    break;

  case 33:
#line 266 "grammar.y"
    {
    NxpElement *result;
    result = nxp_element_container_new((yyvsp[(1) - (3)].el), (yyvsp[(3) - (3)].el));
    (yyval.el) = result;
}
    break;

  case 34:
#line 272 "grammar.y"
    {
    NxpElement* result;
    result = elem_GET_FROM_MATRIX((yyvsp[(1) - (7)].el),(yyvsp[(4) - (7)].el),(yyvsp[(6) - (7)].el)); 
    (yyval.el) = result;
}
    break;

  case 35:
#line 280 "grammar.y"
    {
    (yyval.el) = nxp_element_list_new();
}
    break;

  case 36:
#line 283 "grammar.y"
    { (yyval.el) = nxp_element_list_new_simple((yyvsp[(1) - (2)].el)); NXP_ELEMENT_UNREF((yyvsp[(1) - (2)].el)); }
    break;

  case 37:
#line 284 "grammar.y"
    { (yyval.el) = nxp_element_list_new_simple((yyvsp[(1) - (2)].el)); NXP_ELEMENT_UNREF((yyvsp[(1) - (2)].el)); }
    break;

  case 39:
#line 286 "grammar.y"
    { nxp_element_list_append((yyvsp[(1) - (3)].el), (yyvsp[(2) - (3)].el)); NXP_ELEMENT_UNREF((yyvsp[(2) - (3)].el)); }
    break;

  case 40:
#line 287 "grammar.y"
    { nxp_element_list_append((yyvsp[(1) - (3)].el), (yyvsp[(2) - (3)].el)); NXP_ELEMENT_UNREF((yyvsp[(2) - (3)].el)); }
    break;

  case 41:
#line 295 "grammar.y"
    {
    GPtrArray* array;
    array = g_ptr_array_new();
    g_ptr_array_add(array, (yyvsp[(1) - (3)].array));
    g_ptr_array_add(array, (yyvsp[(3) - (3)].array));
    (yyval.array) = array;
}
    break;

  case 42:
#line 302 "grammar.y"
    {
    g_ptr_array_add((yyvsp[(1) - (3)].array), (yyvsp[(3) - (3)].array));
    (yyval.array) = (yyvsp[(1) - (3)].array);
}
    break;

  case 43:
#line 313 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 44:
#line 314 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 45:
#line 315 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 46:
#line 316 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 47:
#line 317 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 48:
#line 318 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 49:
#line 319 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 50:
#line 320 "grammar.y"
    { (yyval.el) = (yyvsp[(1) - (1)].atom); }
    break;

  case 51:
#line 324 "grammar.y"
    {    
    NxpArg args;
    args.list = nxp_element_list_new_simple((yyvsp[(1) - (1)].el));
    args.named_arg = g_hash_table_new_full(g_str_hash, g_str_equal,
					   g_free, nxp_element_data_unref);
    NXP_ELEMENT_UNREF((yyvsp[(1) - (1)].el));
    (yyval.args) = args;
}
    break;

  case 52:
#line 332 "grammar.y"
    {
    nxp_element_list_append(NXP_ELEMENT((yyvsp[(1) - (3)].args).list), (yyvsp[(3) - (3)].el));
    NXP_ELEMENT_UNREF((yyvsp[(3) - (3)].el));
    (yyval.args) = (yyvsp[(1) - (3)].args);
}
    break;

  case 53:
#line 337 "grammar.y"
    {
    char *named_arg = nxp_identifier_to_string((yyvsp[(3) - (5)].id));
    nxp_identifier_unref((yyvsp[(3) - (5)].id));
    g_hash_table_insert((yyvsp[(1) - (5)].args).named_arg, named_arg, (yyvsp[(5) - (5)].el));
    (yyval.args) = (yyvsp[(1) - (5)].args);
}
    break;

  case 54:
#line 346 "grammar.y"
    {(yyval.atom) = (yyvsp[(1) - (1)].el);}
    break;

  case 55:
#line 347 "grammar.y"
    {
    NxpElement *expr, *args;
    expr = nxp_element_function_new_simple(":", (yyvsp[(5) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (6)].el));
    args = nxp_element_list_new();
    nxp_element_list_append(args, (yyvsp[(2) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (6)].el));
    nxp_element_list_append(args, expr);
    NXP_ELEMENT_UNREF(expr);
    (yyval.atom) = nxp_element_function_new_simple("if", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 56:
#line 359 "grammar.y"
    {
    NxpElement *expr1, *expr2, *args;
    expr1 = nxp_element_function_new_simple(":", (yyvsp[(5) - (10)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (10)].el));
    expr2 = nxp_element_function_new_simple(":", (yyvsp[(9) - (10)].el));
    NXP_ELEMENT_UNREF((yyvsp[(9) - (10)].el));
    args = nxp_element_list_new_simple((yyvsp[(2) - (10)].el));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (10)].el));
    nxp_element_list_append(args, expr1);
    NXP_ELEMENT_UNREF(expr1);
    nxp_element_list_append(args, expr2);
    NXP_ELEMENT_UNREF(expr2);
    (yyval.atom) = nxp_element_function_new_simple("if", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 57:
#line 374 "grammar.y"
    {
    NxpElement *args;
    args = nxp_element_list_new_simple((yyvsp[(3) - (6)].el));
    nxp_element_list_append(args, (yyvsp[(5) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(3) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (6)].el));
    (yyval.atom) = nxp_element_function_new_simple("if", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 58:
#line 383 "grammar.y"
    {
    NxpElement *args;
    args = nxp_element_list_new_simple((yyvsp[(3) - (8)].el));
    nxp_element_list_append(args, (yyvsp[(5) - (8)].el));
    nxp_element_list_append(args, (yyvsp[(7) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(3) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(7) - (8)].el));
    (yyval.atom) = nxp_element_function_new_simple("if", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 59:
#line 393 "grammar.y"
    {
    NxpElement *args, *expr;
    args = nxp_element_list_new_simple((yyvsp[(2) - (8)].atom));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (8)].atom));
    nxp_element_list_append(args, (yyvsp[(4) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(4) - (8)].el));
    expr = nxp_element_function_new_simple(":", (yyvsp[(7) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(7) - (8)].el));
    nxp_element_list_append(args, expr);
    NXP_ELEMENT_UNREF(expr);
    (yyval.atom) = nxp_element_function_new_simple("for", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 60:
#line 405 "grammar.y"
    {
    NxpElement *args;
    args = nxp_element_list_new();
    nxp_element_list_append(args, (yyvsp[(3) - (8)].atom));
    NXP_ELEMENT_UNREF((yyvsp[(3) - (8)].atom));
    nxp_element_list_append(args, (yyvsp[(5) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (8)].el));
    nxp_element_list_append(args, (yyvsp[(7) - (8)].el));
    NXP_ELEMENT_UNREF((yyvsp[(7) - (8)].el));
    (yyval.atom) = nxp_element_function_new_simple("for", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 61:
#line 416 "grammar.y"
    {
    NxpElement *args;
    args = nxp_element_list_new_simple((yyvsp[(2) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (6)].el));
    nxp_element_list_append_list(args, (yyvsp[(5) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (6)].el));
    (yyval.atom) = nxp_element_function_new_simple("while", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 62:
#line 424 "grammar.y"
    {
    NxpElement *args;
    args = nxp_element_list_new_simple((yyvsp[(3) - (6)].el));
    nxp_element_list_append_list(args, (yyvsp[(5) - (6)].args).list);
    NXP_ELEMENT_UNREF((yyvsp[(3) - (6)].el));
    NXP_ELEMENT_UNREF((yyvsp[(5) - (6)].args).list);
    (yyval.atom) = nxp_element_function_new_simple("while", args);
    NXP_ELEMENT_UNREF(args);
}
    break;

  case 63:
#line 435 "grammar.y"
    {
    (yyval.el) = nxp_element_function_new((yyvsp[(1) - (3)].id), (yyvsp[(2) - (3)].args).list, (yyvsp[(2) - (3)].args).named_arg);
    NXP_ELEMENT_UNREF((yyvsp[(2) - (3)].args).list);
    nxp_identifier_unref((yyvsp[(1) - (3)].id));
}
    break;

  case 64:
#line 440 "grammar.y"
    {
    (yyval.el) = nxp_element_function_new((yyvsp[(1) - (3)].id), (yyvsp[(2) - (3)].args).list, (yyvsp[(2) - (3)].args).named_arg);
    NXP_ELEMENT_UNREF((yyvsp[(2) - (3)].args).list);
    nxp_identifier_unref((yyvsp[(1) - (3)].id));
}
    break;

  case 65:
#line 446 "grammar.y"
    {
    NxpElement *list = nxp_element_list_new();
    (yyval.el) = nxp_element_function_new((yyvsp[(1) - (2)].id), list, NULL);
    NXP_ELEMENT_UNREF(list);
    nxp_identifier_unref((yyvsp[(1) - (2)].id));
}
    break;

  case 66:
#line 452 "grammar.y"
    {
    NxpElement *list = nxp_element_list_new();
    (yyval.el) = nxp_element_function_new((yyvsp[(1) - (2)].id), list, NULL);
    NXP_ELEMENT_UNREF(list);
    nxp_identifier_unref((yyvsp[(1) - (2)].id));
}
    break;

  case 67:
#line 461 "grammar.y"
    {
    int pos, size;
    NxpElementVector *vec;
    NxpElement *el;

    size = (yyvsp[(2) - (3)].array)->len;
    vec = NXP_ELEMENT_VECTOR(nxp_element_vector_new(size, NULL));
    for (pos = 0; pos < size; pos++) {
	el = g_ptr_array_index((yyvsp[(2) - (3)].array), pos);
	_element_vector_index(vec, pos) = el;
    }
    g_ptr_array_free((yyvsp[(2) - (3)].array), TRUE);

    (yyval.atom) = NXP_ELEMENT(vec);
}
    break;

  case 68:
#line 476 "grammar.y"
    {
    (yyval.atom) = elem_DOT3((yyvsp[(2) - (5)].el),(yyvsp[(4) - (5)].el)); 
}
    break;

  case 69:
#line 479 "grammar.y"
    {
    (yyval.atom) = nxp_element_vector_new(0, NULL);
}
    break;

  case 70:
#line 486 "grammar.y"
    {
    GPtrArray* array;
    array = g_ptr_array_new();
    g_ptr_array_add(array, (yyvsp[(1) - (1)].el));
    (yyval.array) = array;
}
    break;

  case 71:
#line 492 "grammar.y"
    {
    g_ptr_array_add((yyvsp[(1) - (3)].array), (yyvsp[(3) - (3)].el));
    (yyval.array) = (yyvsp[(1) - (3)].array);
}
    break;

  case 72:
#line 497 "grammar.y"
    {
    guint i, j, height, width, pmax;
    NxpElementMatrix *m;
    GPtrArray *mline;
    
    mline = (yyvsp[(2) - (3)].array);
    height = mline->len;		/* height of matrix */
    /* get maximum of widths of each row in the matrix */
    width = 0;

    for (i = 0; i < height; i++) {
	pmax = ((GPtrArray*) (g_ptr_array_index(mline, i)))->len;
	if (pmax > width)
	    width = pmax;
    }

    m = NXP_ELEMENT_MATRIX(nxp_element_matrix_new(width, height, NULL));
    for (i = 0; i < height; i++)
	for (j = 0; j < width; j++)
	    if (j < ((GPtrArray*)g_ptr_array_index(mline, i))->len)
		_element_matrix_index(m, i, j) =  
		    g_ptr_array_index(
			((GPtrArray*)g_ptr_array_index(mline, i)), j);
	    else
		_element_matrix_index(m, i, j) =  nxp_element_int_new(0);
    
    for (i = 0; i < height; i++)
	g_ptr_array_free((GPtrArray*)g_ptr_array_index(mline, i), TRUE);
    g_ptr_array_free(mline, TRUE);

    (yyval.atom) = NXP_ELEMENT(m);
}
    break;

  case 73:
#line 531 "grammar.y"
    {
    (yyval.atom) = nxp_element_variable_new((yyvsp[(1) - (1)].id));
    nxp_identifier_unref((yyvsp[(1) - (1)].id));
}
    break;

  case 74:
#line 535 "grammar.y"
    {
    (yyval.atom) = nxp_element_tree_new(NXP_OP_PLUS2_LEFT, NULL, (yyvsp[(2) - (2)].atom));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (2)].atom));
}
    break;

  case 75:
#line 539 "grammar.y"
    {
    (yyval.atom) = nxp_element_tree_new(NXP_OP_MINUS2_LEFT, NULL, (yyvsp[(2) - (2)].atom));
    NXP_ELEMENT_UNREF((yyvsp[(2) - (2)].atom));
}
    break;


/* Line 1267 of yacc.c.  */
#line 2366 "grammar.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 546 "grammar.y"


/* END OF FILE */

